<?php

namespace HCM\Geral\Entity;

use HCM\Util\Repositories;
use HCM\Util\MsgCalculo;
use HCM\Util\Util;
use HCM\Util\FPA;
use HCM\Util\TkEntity;
use Zeedhi\Framework\Session\Session;
use Zeedhi\Framework\ORM\DateTime;
use Teknisa\Libs\Util\DateUtil;

class GpeAlteocupacaoEntity
{
    
    private $vinculo;
    
    public function __construct($entityManager, $hcmParameters){
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function retornaUltimaAlteracaoOcupacaoVinculo($nrOrg, $mesCompetencia, $nrVinculo){
        $resultado = $this->entityManager->getRepository(Repositories::GPE_ALTEOCUPACAO)->retornaUltimaAlteracaoOcupacaoVinculo($nrOrg, $mesCompetencia, $nrVinculo);
        return $resultado;
    }


    public function retornaAlteracaoOcupacaoVinculo($nrOrg, $nrVinculo){
        $resultado = GpeAlteocupacao::retornaAlteracaoOcupacaoVinculo($nrOrg, $nrVinculo);
        return $resultado;
    }

    public function retornaUltimaOcupacaoPorDataInicio($nrOrg, $nrVinculo, $dtiniocupacao){
        $resultado = GpeAlteocupacao::getUltimaOcupacaoPorDatainicio($nrOrg, $nrVinculo, $dtiniocupacao);
        return $resultado;
    }

    public function retornaProximaAlteOcupacao($nrOrg, $nrVinculo, $dtiniocupacao){
        $resultado = GpeAlteocupacao::getProximaAlteOcupacao($nrOrg, $nrVinculo, $dtiniocupacao);
        return $resultado;
    }

    public function insereAlteracaoOcupacao($nrorg, $nrvinculom, $dtalteracaocargo, $nrocupacaom, $nrtipoocupacao,
                                            $dtfimocupacao) {
        $this->setNrorg($nrorg);
        $this->setNrvinculom($nrvinculom);
        $this->setDtiniocupacao($dtalteracaocargo);
        $this->setNrocupacaom($nrocupacaom);
        $this->setNrtipoocupacao($nrtipoocupacao);
        $this->setDtfimocupacao($dtfimocupacao);
    }

    public function getVinculo() {
        if (!$this->vinculo) {
            $this->vinculo = Gpevinculom::getVinculo($this->getNrorg(), $this->getNrvinculom());
        }
        return $this->vinculo;
    }

}

